#pragma once

#include <functional>

#include "ClusteringInterface.h"

class AdaptiveEnsembleStrategy :
	public ClusteringInterface
{

public:

	AdaptiveEnsembleStrategy(
		int d,
		std::function<double(double q, int k)> f,
		int k0,
		int l,
		double r,
		ClusteringInterface *final_algorithm,
		int k_max,
		bool iterative);
	~AdaptiveEnsembleStrategy();

	Partition *DetectCommunities(Graph *graph,
		Partition *partition,
		double &q) override;

private:

	Partition *DetectCommunitiesIterative(Graph *graph,
		Partition *partition,
		double &q);

	int d_;
	std::function<double(double q, int k)> f_;
	int k0_;
	int k_max_;
	int l_;
	double r_;
	bool iterative_;
	ClusteringInterface *final_algorithm_;

};

